/**
 * Clock is the class that schedule a task to update the GUI
 * @author Rosalva Gallardo
 * @version 1.0.1
 */

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observer;
import java.util.Timer; 
import java.util.TimerTask; 


public class Clock implements ISubject  {  
    Timer timer; 
    private ArrayList observers = new ArrayList();
	/** 
     * Constructor of the class that receive a time to schedule a task 
     * @param miliseconds time in miliseconds to schedule the task
     */
    public Clock (int miliseconds )   {  
        timer = new Timer (  ) ; 
        timer.schedule ( new RemindTask (  ) , miliseconds, miliseconds) ; 
     }  
    
	/** 
     * Stop the timer 
     */
    public void stop()
    {
    	timer.cancel();
    }
 
	/** 
     * Class that represents the task to be scheduled 
     */
    class RemindTask extends TimerTask  {  
        public void run (  )   {  
            //System.out.println ( "Time's up!" ) ;
            notifyObservers();
     
         }  
     }  
 
	/** 
     * Add an observer 
     * @param o observer to be added
     */
    public void addObserver(Observer o) {
    	observers.add( o );
    	// TODO Auto-generated method stub
    	
    }
	/** 
     * Remove an observer 
     * @param o observer to be removed
     */
    public void removeObserver(Observer o) {
    	// TODO Auto-generated method stub
    	observers.remove( o );
    }
	/** 
     * Notify all observers 
     */    
    private void notifyObservers() {
        // loop through and notify each observer
        Iterator i = observers.iterator();
        while( i.hasNext() ) {
              Observer o = ( Observer ) i.next();
              o.update( null, this );
        }
    }
 }  
